<script lang="ts">
  import { createEventDispatcher } from "svelte";

  /**
   * Is this the principal call to action on the page?
   */
  export let primary = false;

  /**
   * What background color to use
   */
  export let backgroundColor: string | undefined = undefined;
  /**
   * How large should the button be?
   */
  export let size: "small" | "medium" | "large";

  const dispatcher = createEventDispatcher<{
    click: undefined;
  }>();

  function fireClick() {
    // Event comment =)
    dispatcher("click");
  }

  $: mode = primary ? "storybook-button--primary" : "storybook-button--secondary";

  $: style = backgroundColor ? `background-color: ${backgroundColor}` : "";
</script>

<button
  type="button"
  class={["storybook-button", `storybook-button--${size}`, mode].join(" ")}
  {style}
  on:click={fireClick}
>
  <!-- Slot comment =) -->
  <slot />
</button>

<style lang="scss">
  @use "$styles/variables.scss" as vars;

  .storybook-button {
    font-family: vars.$font-family;
    font-weight: 700;
    border: 0;
    border-radius: 3em;
    cursor: pointer;
    display: inline-block;
    line-height: 1;
  }
  .storybook-button--primary {
    color: white;
    background-color: #1ea7fd;
  }
  .storybook-button--secondary {
    color: #333;
    background-color: transparent;
    box-shadow: rgba(0, 0, 0, 0.15) 0px 0px 0px 1px inset;
  }
  .storybook-button--small {
    font-size: 12px;
    padding: 10px 16px;
  }
  .storybook-button--medium {
    font-size: 14px;
    padding: 11px 20px;
  }
  .storybook-button--large {
    font-size: 16px;
    padding: 12px 24px;
  }
</style>
